Name:           sblim-cmpi-rpm
Version:        1.0.1
Release:        9%{?dist}
Summary:        CIM access to installed software packages (currently RPMs)

Group:          Applications/System
License:        CPL
URL:            http://sblim.wiki.sourceforge.net/ProviderCmpiRpm
Source0:        http://downloads.sourceforge.net/sblim/%{name}-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Patch0:         sblim_cmpi_rpm_ldl_library.patch
BuildRequires:  sblim-cmpi-base-devel sblim-cmpi-devel rpm-devel
Requires:       sblim-cmpi-base
Requires:       cim-server

%description
These providers list the software packages installed in a GNU/Linux system
and provide some more details about them. 


%prep
%setup -q

# Patch added to fix the missing definitions of dlopen, dlsym, dlerror.
%patch0


%build
%configure --disable-static
make
#make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
rm -f $RPM_BUILD_ROOT/%{_libdir}/cmpi/*.la
rm -f $RPM_BUILD_ROOT/%{_libdir}/*.la 

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%{_libdir}/libcimrpm.so.0
%{_libdir}/libcimrpm.so.0.0.0
%{_libdir}/libcimrpmv4.so.0
%{_libdir}/libcimrpmv4.so.0.0.0
%{_libdir}/libcimrpm.so
%{_libdir}/libcimrpmv4.so
%{_libdir}/cmpi/libcmpiOSBase_RpmAssociatedFileProvider.so.0
%{_libdir}/cmpi/libcmpiOSBase_RpmAssociatedFileProvider.so.0.0.0
%{_libdir}/cmpi/libcmpiOSBase_RpmFileCheckProvider.so.0
%{_libdir}/cmpi/libcmpiOSBase_RpmFileCheckProvider.so.0.0.0
%{_libdir}/cmpi/libcmpiOSBase_RpmPackageProvider.so.0
%{_libdir}/cmpi/libcmpiOSBase_RpmPackageProvider.so.0.0.0
%{_libdir}/cmpi/libcmpiOSBase_RpmAssociatedFileProvider.so
%{_libdir}/cmpi/libcmpiOSBase_RpmFileCheckProvider.so
%{_libdir}/cmpi/libcmpiOSBase_RpmPackageProvider.so
%{_datarootdir}/sblim-cmpi-rpm/Linux_RpmPackage.mof
%{_datarootdir}/sblim-cmpi-rpm/Linux_RpmPackage.registration
%{_datarootdir}/sblim-cmpi-rpm/provider-register.sh
%{_includedir}/sblim/cimrpm.h
%{_includedir}/sblim/cimrpmfp.h
%doc COPYING NEWS INSTALL README AUTHORS


%define SCHEMA %{_datadir}/%{name}/Linux_RpmPackage.mof
%define REGISTRATION %{_datadir}/%{name}/Linux_RpmPackage.registration

%pre     
function unregister()
{
  %{_datadir}/%{name}/provider-register.sh -d \
        $1 \
        -m %{SCHEMA} \
        -r %{REGISTRATION} > /dev/null 2>&1 || :;
  # don't let registration failure when server not running fail upgrade!
}

# If upgrading, deregister old version
if [ $1 -gt 1 ]
then
        unregistered=no
        if [ -e /usr/sbin/cimserver ]; then
           unregister "-t pegasus";
           unregistered=yes
        fi  
         
        if [ -e /usr/sbin/sfcbd ]; then
           unregister "-t sfcb";
           unregistered=yes
        fi  
         
        if [ "$unregistered" != yes ]; then
           unregister
        fi  
fi


%post    
function register()
{        
  # The follwoing script will handle the registration for various CIMOMs.
  %{_datadir}/%{name}/provider-register.sh \
        $1 \
        -m %{SCHEMA} \
        -r %{REGISTRATION} > /dev/null 2>&1 || :;
  # don't let registration failure when server not running fail install!
}        
         
/sbin/ldconfig
if [ $1 -ge 1 ]
then     
        registered=no
        if [ -e /usr/sbin/cimserver ]; then
          register "-t pegasus";
          registered=yes
        fi
         
        if [ -e /usr/sbin/sfcbd ]; then
          register "-t sfcb";
          registered=yes
        fi
         
        if [ "$registered" != yes ]; then
          register
        fi
fi


%preun   
function unregister()
{        
  %{_datadir}/%{name}/provider-register.sh -d \
        $1 \
        -m %{SCHEMA} \
        -r %{REGISTRATION} > /dev/null 2>&1 || :;
  # don't let registration failure when server not running fail erase!
}        
         
if [ $1 -eq 0 ]
then     
        unregistered=no
        if [ -e /usr/sbin/cimserver ]; then
          unregister "-t pegasus";
          unregistered=yes
        fi
         
        if [ -e /usr/sbin/sfcbd ]; then
          unregister "-t sfcb";
          unregistered=yes
        fi
         
        if [ "$unregistered" != yes ]; then
          unregister
        fi
fi       
         
%postun -p /sbin/ldconfig


%changelog
* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.1-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.1-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.1-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Oct 25 2011 Vitezslav Crhonek <vcrhonek@redhat.com> - 1.0.1-6
- Add mofs registration for various CIMOMs
- Remove -devel subpackage, those files should be in main package, otherwise
  the provider will not work
- Fix spec file formatting to make rpmlint happy

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Aug 11 2009 Praveen K Paladugu <praveen_paladugu@dell.com> - 1.0.1-4
- Added a comment about the patch.
- fixed the description

* Mon Aug 10 2009 Praveen K Paladugu <praveen_paladugu@dell.com> - 1.0.1-3
- Added the scriplets
- Fixing some rpmlint errors.
- Added a patch to add ldl library while linking.
- Removed the .la and .a files.

* Mon Jul 13 2009 Praveen K Paladugu <praveen_paladugu@dell.com> - 1.0.1-2
- Adding BuildRequries sblim-base-devel

* Thu Jul 02 2009 Praveen K Paladugu <praveen_paladugu@dell.com> - 1.0.1-1
- Packaging for Fedora

